using System;
using System.IO;
using System.Text;
using System.Security.Permissions;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Security;
using Microsoft.SharePoint.Utilities;
using Microsoft.SharePoint.Workflow;


namespace Ereignis.EventReceiver1
{
    /// <summary>
    /// Listenelementereignisse
    /// </summary>
    public class EventReceiver1 : SPItemEventReceiver
    {
        
        
        
        /// <summary>
       /// Ein Element wird hinzugefgt..
       /// </summary>
       public override void ItemAdding(SPItemEventProperties properties)
       {
           base.ItemAdding(properties);
           writeDataToLogFile(properties, "NEU     ___");
           writeListItemToCustomerList(properties, "NEU");
       }

       /// <summary>
       /// Ein Element wird aktualisiert..
       /// </summary>
       public override void ItemUpdating(SPItemEventProperties properties)
       {
           base.ItemUpdating(properties);
           writeDataToLogFile(properties, "Geaendert _");
           writeListItemToCustomerList(properties, "Gendert");
       }

       /// <summary>
       /// Ein Element wird gelscht..
       /// </summary>
       public override void ItemDeleting(SPItemEventProperties properties)
       {
           base.ItemDeleting(properties);
           writeDataToLogFile(properties, "Gelscht __");
           writeListItemToCustomerList(properties, "GELSCHT");
       }

       private void writeDataToLogFile(SPItemEventProperties properties, string eventName)
       {
           FileIOPermission myPermissions = new FileIOPermission(PermissionState.Unrestricted);
           myPermissions.AddPathList(FileIOPermissionAccess.AllAccess, "c:\\Authoring");

           StreamWriter sw = File.AppendText(@"C:\Authoring\mySPLog.txt");
           StringBuilder sb = new StringBuilder();
           string nutzer = properties.UserLoginName;
           nutzer = nutzer.Substring(15);
           nutzer = nutzer.ToUpper();
           sw.WriteLine("----------------------------------------------------------------------------------------------------");

           sb.AppendFormat("\n {0} {1} {2} {3} {4} {5} ",
           "Liste: ", properties.ListTitle, DateTime.Now.ToString(), eventName, " durch: ", nutzer);
           sw.WriteLine(sb.ToString());
           sw.Close();
       }

       private void writeListItemToCustomerList(SPItemEventProperties properties, string eventName)
       {
           string spLog = "";
           string spNutzer = "";
           string spEreignis = eventName;
           string currentUser = properties.UserLoginName;
           currentUser = currentUser.Substring(15);
           spNutzer = currentUser.ToUpper();

           DateTime currentTime = DateTime.Now;
           
           spLog = "Liste: " + eventName + "  Datum/Uhrzeit: " + currentTime.ToString() + " durch: " + currentUser ;

           using (SPSite site = new SPSite("http://serv2008-64bit/logdaten"))
           {
               using (SPWeb web = site.OpenWeb())
               {
                   web.AllowUnsafeUpdates = true;
                   SPList list = web.Lists["LogListe"];
                   SPListItem Item = list.Items.Add();
                   Item["Titel"] = properties.ListTitle.ToString();
                   Item["KurzInfo"] = spLog;
                   Item["Nutzer"] = spNutzer;
                   Item["Ereignis"] = spEreignis;
                   Item.Update();
               }
           }

           
       }

       

    }
}
